<a id="mypy-boto3-amplifyuibuilder"></a>

# mypy-boto3-amplifyuibuilder

[![PyPI - mypy-boto3-amplifyuibuilder](https://img.shields.io/pypi/v/mypy-boto3-amplifyuibuilder.svg?color=blue)](https://pypi.org/project/mypy-boto3-amplifyuibuilder)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-amplifyuibuilder.svg?color=blue)](https://pypi.org/project/mypy-boto3-amplifyuibuilder)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-amplifyuibuilder?color=blue)](https://pypistats.org/packages/mypy-boto3-amplifyuibuilder)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.AmplifyUIBuilder 1.20.46](https://boto3.amazonaws.com/v1/documentation/api/1.20.46/reference/services/amplifyuibuilder.html#AmplifyUIBuilder)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.1](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-amplifyuibuilder docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_amplifyuibuilder/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-amplifyuibuilder](#mypy-boto3-amplifyuibuilder)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `AmplifyUIBuilder`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `AmplifyUIBuilder` service.

```bash
python -m pip install boto3-stubs[amplifyuibuilder]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[amplifyuibuilder]` in your environment:
  `python -m pip install 'boto3-stubs[amplifyuibuilder]'`

Both type checking and auto-complete should work for `AmplifyUIBuilder`
service. No explicit type annotations required, write your `boto3` code as
usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto3-stubs[amplifyuibuilder]` in your environment:
  `python -m pip install 'boto3-stubs[amplifyuibuilder]'`

Both type checking and auto-complete should work for `AmplifyUIBuilder`
service. No explicit type annotations required, write your `boto3` code as
usual. Auto-complete can be slow on big projects or if you have a lot of
installed `boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[amplifyuibuilder]` in your environment:
  `python -m pip install 'boto3-stubs[amplifyuibuilder]'`
- Run `mypy` as usual

Type checking should work for `AmplifyUIBuilder` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto3-stubs[amplifyuibuilder]` in your environment:
  `python -m pip install 'boto3-stubs[amplifyuibuilder]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `AmplifyUIBuilder` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`AmplifyUIBuilderClient` provides annotations for
`boto3.client("amplifyuibuilder")`.

```python
import boto3

from mypy_boto3_amplifyuibuilder import AmplifyUIBuilderClient

client: AmplifyUIBuilderClient = boto3.client("amplifyuibuilder")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: AmplifyUIBuilderClient = session.client("amplifyuibuilder")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_amplifyuibuilder.paginator` module contains type annotations for
all paginators.

```python
from mypy_boto3_amplifyuibuilder import AmplifyUIBuilderClient
from mypy_boto3_amplifyuibuilder.paginator import (
    ListComponentsPaginator,
    ListThemesPaginator,
)

client: AmplifyUIBuilderClient = boto3.client("amplifyuibuilder")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_components_paginator: ListComponentsPaginator = client.get_paginator("list_components")
list_themes_paginator: ListThemesPaginator = client.get_paginator("list_themes")
```

<a id="literals"></a>

### Literals

`mypy_boto3_amplifyuibuilder.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_amplifyuibuilder.literals import (
    ListComponentsPaginatorName,
    ListThemesPaginatorName,
    SortDirectionType,
    TokenProvidersType,
    ServiceName,
    PaginatorName,
)

def check_value(value: ListComponentsPaginatorName) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_amplifyuibuilder.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_amplifyuibuilder.type_defs import (
    ComponentBindingPropertiesValuePropertiesTypeDef,
    ComponentBindingPropertiesValueTypeDef,
    ComponentChildTypeDef,
    ComponentConditionPropertyTypeDef,
    ComponentDataConfigurationTypeDef,
    ComponentPropertyBindingPropertiesTypeDef,
    ComponentPropertyTypeDef,
    ComponentSummaryTypeDef,
    ComponentTypeDef,
    ComponentVariantTypeDef,
    CreateComponentDataTypeDef,
    CreateComponentRequestRequestTypeDef,
    CreateComponentResponseTypeDef,
    CreateThemeDataTypeDef,
    CreateThemeRequestRequestTypeDef,
    CreateThemeResponseTypeDef,
    DeleteComponentRequestRequestTypeDef,
    DeleteThemeRequestRequestTypeDef,
    ExchangeCodeForTokenRequestBodyTypeDef,
    ExchangeCodeForTokenRequestRequestTypeDef,
    ExchangeCodeForTokenResponseTypeDef,
    ExportComponentsRequestRequestTypeDef,
    ExportComponentsResponseTypeDef,
    ExportThemesRequestRequestTypeDef,
    ExportThemesResponseTypeDef,
    FormBindingElementTypeDef,
    GetComponentRequestRequestTypeDef,
    GetComponentResponseTypeDef,
    GetThemeRequestRequestTypeDef,
    GetThemeResponseTypeDef,
    ListComponentsRequestRequestTypeDef,
    ListComponentsResponseTypeDef,
    ListThemesRequestRequestTypeDef,
    ListThemesResponseTypeDef,
    PaginatorConfigTypeDef,
    PredicateTypeDef,
    RefreshTokenRequestBodyTypeDef,
    RefreshTokenRequestRequestTypeDef,
    RefreshTokenResponseTypeDef,
    ResponseMetadataTypeDef,
    SortPropertyTypeDef,
    ThemeSummaryTypeDef,
    ThemeTypeDef,
    ThemeValueTypeDef,
    ThemeValuesTypeDef,
    UpdateComponentDataTypeDef,
    UpdateComponentRequestRequestTypeDef,
    UpdateComponentResponseTypeDef,
    UpdateThemeDataTypeDef,
    UpdateThemeRequestRequestTypeDef,
    UpdateThemeResponseTypeDef,
)

def get_structure() -> ComponentBindingPropertiesValuePropertiesTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-amplifyuibuilder` version is the same as related `boto3` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-amplifyuibuilder docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_amplifyuibuilder/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
